ALTER TABLE Trn_Nomina ADD NE_ComAju BIT DEFAULT(0) NOT NULL,NE_CntAju INT DEFAULT(0) NOT NULL,NE_Ajustes VARCHAR(500)
GO
INSERT INTO Sys_ObjetosApp (IdObj,IdGrupo,SubModulo,IndObj,Nombre,Formulario,Permisos,NivelMinimo,NomArchivo)
 VALUES ('FRMLRHN','NOMINF','GEN',17,'Resumen Histórico de Nómina','FRMLRHN','S',0,'')
GO
INSERT INTO Sys_Report (TipoRep,IdRep,Descripcion,Formato,TipoPapel,Orientacion,VistaPrevia,VerSetup,NumCopias,sp_Nombre,Ind_Location,NomRep)
 VALUES ('RHN','01','Predeterminado','CrRhn.rpt',1,1,1,0,1,'paQryNERecordLta','','Resumen Histórico de Nómina')
GO

CREATE TABLE Trn_NERecord ( 
TipoReg VARCHAR(3) NOT NULL,
NumRegistro INT DEFAULT ((0)) NOT NULL,
IdCia CHAR(2) NOT NULL,
Fecha SMALLDATETIME NOT NULL,
IdPeriodo VARCHAR(8) NOT NULL,
IdEmpleado VARCHAR(16) NOT NULL,
NContrato INT DEFAULT ((0)) NOT NULL,
IdRegNom VARCHAR(30) NOT NULL,
NumLiquida INT DEFAULT ((0)) NOT NULL,
NumSemLiq INT DEFAULT ((0)) NOT NULL,
FecInicial SMALLDATETIME NOT NULL,
FecFinal SMALLDATETIME NOT NULL,
Cantidad DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
CantNoRem DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
VrDevengado MONEY DEFAULT ((0)) NOT NULL,
VrDeducido MONEY DEFAULT ((0)) NOT NULL,
IdDep VARCHAR(4) NOT NULL,
IdInstala VARCHAR(4) NOT NULL,
IdCCosto VARCHAR(16) NOT NULL,
IdSubCos VARCHAR(16) NOT NULL,
IdNom VARCHAR(4) NOT NULL,
VrSalario MONEY DEFAULT ((0)) NOT NULL,
VrATransMes MONEY DEFAULT ((0)) NOT NULL,
pVehiculo VARCHAR(10),
FecIniPmd SMALLDATETIME,
FecFinPmd SMALLDATETIME,
DiasVac INT DEFAULT ((0)) NOT NULL,
NPeriodos INT DEFAULT ((0)) NOT NULL,
CantRem INT DEFAULT ((0)) NOT NULL,
VrRemndo MONEY DEFAULT ((0)) NOT NULL,
TipCom VARCHAR(3),
Comprobante INT DEFAULT ((0)) NOT NULL,
IdCiaCom CHAR(2),
Observacion VARCHAR(250),
IdEstado VARCHAR(4) NOT NULL,
EsRetiro BIT DEFAULT ((0)) NOT NULL,
NLiqRet INT DEFAULT ((0)) NOT NULL,
TipoLiq CHAR(1) DEFAULT ('M') NOT NULL,
EsParcial BIT DEFAULT ((0)) NOT NULL,
FechaCrea SMALLDATETIME NOT NULL,
IdUsuario VARCHAR(11) NOT NULL,
CdTipoCot VARCHAR(4),
SubTipo_Cot VARCHAR(3),
Sal_Integral BIT DEFAULT ((0)) NOT NULL,
TipoIdent CHAR(1),
NotasAportante VARCHAR(250),
CantModifica INT,
NE_Estado INT DEFAULT ((0)) NOT NULL,
NE_Prefijo VARCHAR(20),
NE_Numero INT DEFAULT ((0)) NOT NULL,
NE_FecEnvio SMALLDATETIME,
NE_CUNE VARCHAR(500),
NE_QR IMAGE,
NE_CntAju INT DEFAULT ((0)) NOT NULL,
NE_Ajustes VARCHAR(500)
 CONSTRAINT PK_Trn_NERecord PRIMARY KEY CLUSTERED (TipoReg,NumRegistro,IdCia),
 CONSTRAINT CK_Trn_NERecordIdCCosto CHECK ((len([IdCCosto])>(0))),
 CONSTRAINT CK_Trn_NERecordIdCia CHECK ((len([IdCia])>(0))),
 CONSTRAINT CK_Trn_NERecordIdDep CHECK ((len([IdDep])>(0))),
 CONSTRAINT CK_Trn_NERecordIdEmpleado CHECK ((len([IdEmpleado])>(0))),
 CONSTRAINT CK_Trn_NERecordIdEstado CHECK ((len([IdEstado])>(0))),
 CONSTRAINT CK_Trn_NERecordIdInstala CHECK ((len([IdInstala])>(0))),
 CONSTRAINT CK_Trn_NERecordIdNom CHECK ((len([IdNom])>(0))),
 CONSTRAINT CK_Trn_NERecordIdPeriodo CHECK ((len([IdPeriodo])>(0))),
 CONSTRAINT CK_Trn_NERecordIdRegNom CHECK ((len([IdRegNom])>(0))),
 CONSTRAINT CK_Trn_NERecordIdSubCos CHECK ((len([IdSubCos])>(0))),
 CONSTRAINT CK_Trn_NERecordIdUsuario CHECK ((len([IdUsuario])>(0))),
 CONSTRAINT CK_Trn_NERecordTipoLiq CHECK ((len([TipoLiq])>(0))),
 CONSTRAINT CK_Trn_NERecordTipoReg CHECK ((len([TipoReg])>(0))))
GO
CREATE TABLE Trn_NERecordDet ( 
TipoReg VARCHAR(3) NOT NULL,
NumRegistro INT DEFAULT ((0)) NOT NULL,
IdCia CHAR(2) NOT NULL,
Item INT DEFAULT ((0)) NOT NULL,
IdConcepto VARCHAR(4) NOT NULL,
Detalle VARCHAR(250),
CantDevg DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
CantDed DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
VrUnitario MONEY DEFAULT ((0)) NOT NULL,
VrTotDevg MONEY DEFAULT ((0)) NOT NULL,
VrTotDed MONEY DEFAULT ((0)) NOT NULL,
Unidad VARCHAR(10) DEFAULT ('UNIDADES'),
ClaseLiq VARCHAR(10) DEFAULT ('NOMINA') NOT NULL,
VrOrigen MONEY DEFAULT ((0)) NOT NULL,
Tarifa DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
DiasCalc DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
DiasNov DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
CodFondo VARCHAR(8),
NPrestamo INT DEFAULT ((0)) NOT NULL,
NCuota INT DEFAULT ((0)) NOT NULL,
OrigCargue VARCHAR(10),
VrBaseLiq MONEY DEFAULT ((0)) NOT NULL,
VrBasExceso MONEY DEFAULT ((0)),
NitTercero VARCHAR(16),
HoraInicial DATETIME,
HoraFinal DATETIME,
TipoIncLab VARCHAR(20)
 CONSTRAINT PK_Trn_NERecordDet PRIMARY KEY CLUSTERED (TipoReg,NumRegistro,IdCia,Item),
 CONSTRAINT CK_Trn_NERecordDetClaseLiq CHECK ((len([ClaseLiq])>(0))),
 CONSTRAINT CK_Trn_NERecordDetIdCia CHECK ((len([IdCia])>(0))),
 CONSTRAINT CK_Trn_NERecordDetIdConcepto CHECK ((len([IdConcepto])>(0))),
 CONSTRAINT CK_Trn_NERecordDetTipoReg CHECK ((len([TipoReg])>(0))))
GO
CREATE TABLE Trn_NomAjustesCom ( 
Id BIGINT IDENTITY ( 1,1 ) NOT NULL,
TipoReg VARCHAR(3) NOT NULL,
Fecha DATETIME NOT NULL,
IdPeriodo VARCHAR(8) NOT NULL,
IdEmpleado VARCHAR(16) NOT NULL,
NContrato INT DEFAULT ((0)) NOT NULL,
IdCia CHAR(2) NOT NULL,
IdRegNom VARCHAR(30) NOT NULL,
NumLiquida INT DEFAULT ((0)) NOT NULL,
NumSemLiq INT DEFAULT ((0)) NOT NULL,
FecInicial SMALLDATETIME NOT NULL,
FecFinal SMALLDATETIME NOT NULL,
IdDep VARCHAR(4) NOT NULL,
IdInstala VARCHAR(4) NOT NULL,
IdCCosto VARCHAR(16) NOT NULL,
IdSubCos VARCHAR(16) NOT NULL,
IdNom VARCHAR(4) NOT NULL,
VrSalario MONEY DEFAULT ((0)) NOT NULL,
VrATransMes MONEY DEFAULT ((0)) NOT NULL,
pVehiculo VARCHAR(10),
Estado INT DEFAULT ((0)) NOT NULL,
TipCom VARCHAR(3),
Comprobante INT DEFAULT ((0)) NOT NULL,
IdCiaCom CHAR(2),
EsRetiro BIT DEFAULT ((0)) NOT NULL,
NLiqRet INT DEFAULT ((0)) NOT NULL,
TipoLiq CHAR(1) DEFAULT ('M') NOT NULL,
IdConcepto VARCHAR(4) NOT NULL,
Detalle VARCHAR(250),
CantDevg DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
CantDed DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
VrUnitario MONEY DEFAULT ((0)) NOT NULL,
VrTotDevg MONEY DEFAULT ((0)) NOT NULL,
VrTotDed MONEY DEFAULT ((0)) NOT NULL,
ClaseLiq VARCHAR(10) DEFAULT ('NOMINA') NOT NULL,
VrOrigen MONEY DEFAULT ((0)) NOT NULL,
Tarifa DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
DiasCalc DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
DiasNov DECIMAL(10,4) DEFAULT ((0)) NOT NULL,
CodFondo VARCHAR(8),
NPrestamo INT DEFAULT ((0)) NOT NULL,
NCuota INT DEFAULT ((0)) NOT NULL,
VrBaseLiq MONEY DEFAULT ((0)) NOT NULL,
VrBasExceso MONEY DEFAULT ((0)),
NitTercero VARCHAR(16)
 CONSTRAINT PK_Trn_NomAjustesCom PRIMARY KEY NONCLUSTERED (Id),
 CONSTRAINT CK_Trn_NomAjustesComClaseLiq CHECK ((len([ClaseLiq])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdCCosto CHECK ((len([IdCCosto])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdCia CHECK ((len([IdCia])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdConcepto CHECK ((len([IdConcepto])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdDep CHECK ((len([IdDep])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdEmpleado CHECK ((len([IdEmpleado])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdInstala CHECK ((len([IdInstala])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdNom CHECK ((len([IdNom])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdPeriodo CHECK ((len([IdPeriodo])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdRegNom CHECK ((len([IdRegNom])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComIdSubCos CHECK ((len([IdSubCos])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComTipoLiq CHECK ((len([TipoLiq])>(0))),
 CONSTRAINT CK_Trn_NomAjustesComTipoReg CHECK ((len([TipoReg])>(0))))
GO

ALTER TABLE Trn_NERecord ADD 
 CONSTRAINT FK_Trn_NERecord_adm_Usuarios FOREIGN KEY (IdUsuario) REFERENCES [dbo].[adm_Usuarios] (IdUsuario),
 CONSTRAINT FK_Trn_NERecord_Empleados FOREIGN KEY (IdEmpleado) REFERENCES [dbo].[Empleados] (IdEmpleado),
 CONSTRAINT FK_Trn_NERecord_TiposNom FOREIGN KEY (IdNom) REFERENCES [dbo].[TiposNom] (IdNom)

CREATE NONCLUSTERED INDEX IX_Trn_NERecordIdEmpleado ON Trn_NERecord(IdPeriodo,IdEmpleado,NContrato)
 CREATE NONCLUSTERED INDEX IX_Trn_NERecordFecha ON Trn_NERecord(Fecha)

ALTER TABLE Trn_NERecordDet ADD 
 CONSTRAINT FK_Trn_NERecordDet_NomConceptos FOREIGN KEY (IdConcepto) REFERENCES [dbo].[NomConceptos] (IdConcepto),
 CONSTRAINT FK_Trn_NERecordDet_Trn_NERecord FOREIGN KEY (TipoReg,NumRegistro,IdCia) REFERENCES [dbo].[Trn_NERecord] (TipoReg,NumRegistro,IdCia)


